<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Role"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	
	boolean isAdmin = user.getId() == SystemItems.getId(User.ROOT);
	boolean isPatientCurator = false;
	if (!isAdmin)
	{
		try
		{
			Role admin = Role.getById(dc, SystemItems.getId(Role.ADMINISTRATOR));
			isAdmin = sc.isMemberOf(admin);
		}
		catch (RuntimeException ex)
		{}
	}
	try
	{
		ItemQuery<Group> query = Group.getQuery();
		query.restrict(Restrictions.eq(Hql.property("name"), Expressions.string("PatientCurator")));
		List<Group> result = query.list(dc);
		if (result.size() == 1)
		{
			isPatientCurator = sc.isMemberOf(result.get(0));
		}
	}
	catch (RuntimeException ex)
	{}
%>
<base:page type="default" >
<base:head styles="path.css" scripts="ajax.js">
	<script language="JavaScript" src="reggie.js" type="text/javascript" charset="UTF-8"></script>
	<link rel="stylesheet" type="text/css" href="css/reggie.css">
	<script language="JavaScript">
	
	var debug = false;
	var myPermissions = {};
	var allCounts = {};
	
	function init()
	{
		// Get permission information
		var url = 'Install.servlet?ID=<%=ID%>&cmd=GetPermissions';
		var request = Ajax.getXmlHttpRequest();
		request.open("GET", url, false);
		Ajax.setReadyStateHandler(request, onPermissions, onPermissions);
		request.send(null);
	}
	
	// Callback when permission information is ready
	function onPermissions(request)
	{
		if (debug) Main.debug(Main.encodeTags(request.responseText));
		var response;
		var error = false;
		try
		{
			response = JSON.parse(request.responseText);
			if (response.status != 'ok')
			{
				error = response.message || response.stacktrace || 'Unexpected error';
			}
		}
		catch (ex)
		{
			error = ex;
		}
		
		if (error)
		{
			alert(error);
			return;
		}
		
		myPermissions = response.permissions;
		var isAdmin = myPermissions['Administrator'] == 1;
		
		// Enable links based on the permission
		var wizards = document.getElementsByClassName('require-permission');
		// NOTE! Loop backwards since changing the classname 
		// of an element so that 'require-permission' no longer is included
		// removes the element from the 'wizards' list
		for (var wizardNo = wizards.length-1; wizardNo >= 0; wizardNo--)
		{
			var wizard = wizards[wizardNo];
			if (wizard.className.indexOf('not-implemented') == -1)
			{
				var role = wizard.getAttribute('data-role');
				if (myPermissions[role] == 1 || isAdmin)
				{
					wizard.className = 'link';
					wizard.addEventListener('click', goWizard);
				}
				else
				{
					wizard.title = 'You do not have permission to user this wizard';
				}
			}
		}
		
		// Start couting queued items
		startCounting('specimen');
	}
	
	function caseSummary()
	{
		var frm = document.forms['reggie'];
		
		var caseName = frm.caseName.value;
		if (!caseName)
		{
			alert('Please enter a 7-digit case id');
			return;
		}
		location.href = 'reports/case_summary.jsp?ID=<%=ID%>&caseName='+encodeURIComponent(caseName);
	}
	
	var currentCount;
	function startCounting(what)
	{
		var url;
		currentCount = what;
		if (what == 'specimen')
		{
			url = 'PartitionRegistration.servlet?ID=<%=ID%>&cmd=CountSpecimenTubes';
		}
		else if (what == 'histology-lists')
		{
			url = 'Histology.servlet?ID=<%=ID%>&cmd=CountHistologyWorkLists';
		}
		else if (what == 'paraffin-blocks')
		{
			url = 'Histology.servlet?ID=<%=ID%>&cmd=CountParaffinBlocks';
		}
		else if (what == 'paraffin-blocks-without-heglass')
		{
			url = 'Histology.servlet?ID=<%=ID%>&cmd=CountParaffinBlocksWithoutHeGlass';
		}
		else if (what == 'unscored-heglass')
		{
			url = 'Histology.servlet?ID=<%=ID%>&cmd=CountUnscoredHeGlass';
		}
		else if (what == 'lysate')
		{
			url = 'Extraction.servlet?ID=<%=ID%>&cmd=CountUnprocessedLysates';
		}
		else if (what == 'rnaqc')
		{
			url = 'RnaQc.servlet?ID=<%=ID%>&cmd=CountRnaExtractsWithoutQc';
		}
		else if (what == 'caliper-plates')
		{
			url = 'RnaQc.servlet?ID=<%=ID%>&cmd=CountActiveRnaQcBioPlates';
		}
		else if (what == 'rna-without-mrna')
		{
			url = 'MRna.servlet?ID=<%=ID%>&cmd=CountRnaWithoutMRna';
		}
		else if (what == 'undiluted-mrna-plates')
		{
			url = 'MRna.servlet?ID=<%=ID%>&cmd=CountUndilutedMRNAPlates';
		}
		else if (what == 'diluted-mrna-plates')
		{
			url = 'MRna.servlet?ID=<%=ID%>&cmd=CountDilutedMRNAPlates';
		}
		else if (what == 'cdna-plates')
		{
			url = 'MRna.servlet?ID=<%=ID%>&cmd=CountUnprocessedPlates&plateType=CDNA';
		}
		else if (what == 'cdna-plates-for-barcoding')
		{
			url = 'LibPrep.servlet?ID=<%=ID%>&cmd=CountCDNAPlatesForBarcoding';
		}
		else if (what == 'lib-plates')
		{
			url = 'LibPrep.servlet?ID=<%=ID%>&cmd=CountLibPlatesForLibPrep';
		}
		else if (what == 'lib-plates-for-pooling')
		{
			url = 'Pool.servlet?ID=<%=ID%>&cmd=CountLibraryPlatesForPooling';
		}
		else if (what == 'unregistered-pools')
		{
			url = 'Pool.servlet?ID=<%=ID%>&cmd=CountUnprocessedPools';
		}
		else if (what == 'unused-pools')
		{
			url = 'FlowCell.servlet?ID=<%=ID%>&cmd=CountUnusedPools';
		}
		else if (what == 'unregistered-flow-cells')
		{
			url = 'FlowCell.servlet?ID=<%=ID%>&cmd=CountUnprocessedFlowCells';
		}
		else if (what == 'clustered-flow-cells')
		{
			url = 'FlowCell.servlet?ID=<%=ID%>&cmd=CountClusteredFlowCells';
		}
		else if (what == 'active-sequencing-runs')
		{
			url = 'SequencingRun.servlet?ID=<%=ID%>&cmd=CountActiveSequencingRuns';
		}
		else if (what == 'unconfirmed-sequencing-runs')
		{
			url = 'SequencingRun.servlet?ID=<%=ID%>&cmd=CountUncomfirmedSequencingRuns';
		}
		
		if (url)
		{
			var request = Ajax.getXmlHttpRequest();
			request.open("GET", url, true);
			Ajax.setReadyStateHandler(request, onCounted, onCounted);
			request.send(null);
		}
	}
	
	function onCounted(request)
	{
		if (debug) Main.debug(currentCount +': ' + Main.encodeTags(request.responseText));
		var response;
		var error = false;
		try
		{
			response = JSON.parse(request.responseText);
			if (response.status != 'ok')
			{
				error = response.message || response.stacktrace || 'Unexpected error';
			}
		}
		catch (ex)
		{
			error = ex;
		}
		
		if (currentCount == 'specimen')
		{
			var msg = error || 'Number of unpartitioned specimen';
			var count = error ? -1 : response.count;
			setCount('count.specimen', count, 'specimens', msg);
			startCounting('histology-lists');
		}
		else if (currentCount == 'histology-lists')
		{
			var msg = error || 'Number of active histology work lists';
			var count = error ? -1 : response.count;
			setCount('count.histology-lists', count, 'work lists', msg);
			startCounting('paraffin-blocks');
		}
		else if (currentCount == 'paraffin-blocks')
		{
			var msg = error || 'Number of paraffin blocks waiting for registration';
			var count = error ? -1 : response.count;
			setCount('count.paraffin-blocks', count, 'paraffin blocks', msg);
			startCounting('paraffin-blocks-without-heglass');
		}
		else if (currentCount == 'paraffin-blocks-without-heglass')
		{
			var msg = error || 'Number of paraffin blocks without HE glass';
			var count = error ? -1 : response.count;
			setCount('count.paraffin-blocks-without-heglass', count, 'paraffin blocks', msg);
			startCounting('unscored-heglass');
		}
		else if (currentCount == 'unscored-heglass')
		{
			var msg = error || 'Number of unscored HE glass';
			var count = error ? -1 : response.count;
			setCount('count.unscored-heglass', count, 'HE glass', msg);
			startCounting('lysate');
		}
		else if (currentCount == 'lysate')
		{
			var msg = error || 'Number of unprocessed lysates';
			var count = error ? -1 : response.count;
			setCount('count.lysate.1', count, 'lysates', msg);
			setCount('count.lysate.2', count, 'lysates', msg);
			startCounting('rnaqc');
		}
		else if (currentCount == 'rnaqc')
		{
			var msg = error || 'Number of RNA waiting for QC';
			var count = error ? -1 : response.count;
			setCount('count.rnaqc', count, 'RNA', msg);
			startCounting('caliper-plates');
		}
		else if (currentCount == 'caliper-plates')
		{
			var msg = error || 'Number of active Caliper plates';
			var count = error ? -1 : response.count;
			setCount('count.caliper-plates.1', count, 'Caliper plates', msg);
			setCount('count.caliper-plates.2', count, 'Caliper plates', msg);
			startCounting('rna-without-mrna');
		}
		else if (currentCount == 'rna-without-mrna')
		{
			var msg = error || 'Number of RNA with no mRNA';
			var count = error ? -1 : response.count;
			setCount('count.rna-without-mrna', count, 'RNA', msg);
			startCounting('undiluted-mrna-plates');
		}
		else if (currentCount == 'undiluted-mrna-plates')
		{
			var msg = error || 'Number of mRNA plates waiting for dilution';
			var count = error ? -1 : response.count;
			setCount('count.undiluted-mrna-plates', count, 'mRNA plates', msg);
			startCounting('diluted-mrna-plates');
		}
		else if (currentCount == 'diluted-mrna-plates')
		{
			var msg = error || 'Number of mRNA plates waiting for registration';
			var count = error ? -1 : response.count;
			setCount('count.diluted-mrna-plates', count, 'mRNA plates', msg);
			setCount('count.mrna-plates', count + allCounts['count.undiluted-mrna-plates'], 'mRNA plates', 'Number of mRNA plates waiting for processing');
			startCounting('cdna-plates');
		}
		else if (currentCount == 'cdna-plates')
		{
			var msg = error || 'Number of cDNA plates waiting for registration';
			var count = error ? -1 : response.count;
			setCount('count.cdna-plates.1', count, 'cDNA plates', msg);
			startCounting('cdna-plates-for-barcoding');
		}
		else if (currentCount == 'cdna-plates-for-barcoding')
		{
			var msg = error || 'Number of cDNA plates waiting for barcode layout';
			var count = error ? -1 : response.count;
			setCount('count.cdna-plates-for-barcoding', count, 'cDNA plates', msg);
			startCounting('lib-plates')
		}
		else if (currentCount == 'lib-plates')
		{
			var msg = error || 'Number of Lib plates waiting for registration';
			var count = error ? -1 : response.count;
			setCount('count.lib-plates.1', count, 'Lib plates', msg);
			setCount('count.lib-plates.2', count, 'Lib plates', msg);
			setCount('count.lib-plates.3', count, 'Lib plates', msg);
			startCounting('lib-plates-for-pooling');
		}
		else if (currentCount == 'lib-plates-for-pooling')
		{
			var msg = error || 'Number of Lib plates waiting for pooling';
			var count = error ? -1 : response.count;
			setCount('count.lib-plates-for-pooling', count, 'Lib plates', msg);
			startCounting('unregistered-pools');
		}
		else if (currentCount == 'unregistered-pools')
		{
			var msg = error || 'Number of pools waiting for registration';
			var count = error ? -1 : response.count;
			setCount('count.pools.1', count, 'pools', msg);
			setCount('count.pools.2', count, 'pools', msg);
			startCounting('unused-pools');
		}
		else if (currentCount == 'unused-pools')
		{
			var msg = error || 'Number of pools waiting for sequencing';
			var count = error ? -1 : response.count;
			setCount('count.pools.3', count, 'pools', msg);
			startCounting('unregistered-flow-cells');
		}
		else if (currentCount == 'unregistered-flow-cells')
		{
			var msg = error || 'Number of flow cells waiting for clustering';
			var count = error ? -1 : response.count;
			setCount('count.flow-cells.1', count, 'flow cells', msg);
			setCount('count.flow-cells.2', count, 'flow cells', msg);
			startCounting('clustered-flow-cells');
		}
		else if (currentCount == 'clustered-flow-cells')
		{
			var msg = error || 'Number of flow cells waiting for sequencing';
			var count = error ? -1 : response.count;
			setCount('count.flow-cells.3', count, 'flow cells', msg);
			startCounting('active-sequencing-runs');
		}
		else if (currentCount == 'active-sequencing-runs')
		{
			var msg = error || 'Number of active sequencing runs';
			var count = error ? -1 : response.count;
			setCount('count.sequencing-run', count, 'sequencing runs', msg);
			startCounting('unconfirmed-sequencing-runs');
		}
		else if (currentCount == 'unconfirmed-sequencing-runs')
		{
			var msg = error || 'Number of ended but not confirmed sequencing runs';
			var count = error ? -1 : response.count;
			setCount('count.unconfirmed-sequencing-run', count, 'sequencing runs', msg);
		}
		
	}
	
	function setCount(id, count, unit, msg)
	{
		allCounts[id] = count;
		var div = document.getElementById(id);
		div.title = msg;
		if (count == -1)
		{
			div.innerHTML = '(-)';
		}
		else
		{
			div.innerHTML = '(' + count + ')';
		}
	}
	
	function goWizard(event)
	{
		var role = event.currentTarget.getAttribute('data-role');
		var isAdmin = myPermissions['Administrator'] == 1;
		if (isAdmin || myPermissions[role] == 1)
		{
			var link = event.currentTarget.getAttribute('data-link');
			location.href = link;
		}
		else
		{
			alert('You do not have permission to use this wizard!');
		}
	}
	
	</script>
<style>
dl
{
	margin-top: 0px;
	padding: 3px;
}
dt
{
	margin-top: 0.5em;
	margin-left: 0.5em;
}
dd
{
	margin-left: 0.5em;
	margin-bottom: 0.5em;
	padding-left: 3em;
}
ul
{
	margin-top: 0px;
	margin-bottom: 0px;
	margin-left: 0em;
	padding-left: 0em;
}
li
{
	margin-left: 0em;
}
img
{
	vertical-align: text-bottom;
}
h3
{
	color: #333377;
	background: #E8E8E8;
	font-weight: bold;
	margin-bottom: 0em;
	padding: 1px 4px 1px 4px;
	border: 1px solid #A0A0A0;
	font-size: 1em;
}
.not-implemented
{
	filter: url(css/filters.svg#grayscale); /* Firfox, etc */
	filter: gray; /* IE */
	opacity: 0.75;
	pointer-events: none;
}

.not-implemented:after
{
	content: ' -- coming soon';
}
.counter
{
	color: #999999;
	font-style: italic;
}

.require-permission
{
	color: #999999;
	font-style: italic;
}

</style>
</base:head>
<base:body onload="init()">

	<p:path><p:pathelement title="Reggie" /></p:path>

	<div class="content">
		<form name="reggie" onsubmit="return false;">
		<div class="absolutefull" style="width: 33%;">
			<div class="absolutefull" style="left: 1em; right: 0.5em; ">
			
				<h3>Sample processing wizards</h3>
				<dl class="leftborder rightborder bottomborder has-lib-prep">

				<dt>
					<base:icon image="<%=home+"/images/specimen.png" %>" />
					<span class="require-permission" data-role="SamplePrep" data-link="sampleproc/specimentube.jsp?ID=<%=ID%>"
						>Specimen tube registration</span>
				</dt>
				<dd>
					<ul>
					<li>Register new specimen tubes.
					<li>Update existing specimen tubes.
					</ul>
				</dd>

				<dt>
					<base:icon image="<%=home+"/images/partition.png" %>" />
					<span class="require-permission" data-role="SamplePrep" data-link="sampleproc/partitionform.jsp?ID=<%=ID%>"
						>Partition wizard</span>
				</dt>
				<dd>
					<ul>
					<li>Register new partitions of existing specimens <span class="counter" id="count.specimen" title="Counting..."><img src="images/loading-small.gif"></span>
					</ul>
				</dd>
					
				<dt>
					<base:icon image="<%=home+"/images/extraction.png" %>" />
					DNA/RNA extraction wizards
				</dt>
				<dd>
					<ul>
					<li><span class="require-permission" data-role="SamplePrep" data-link="sampleproc/allprep_protocol.jsp?ID=<%=ID%>"
						>Lab tracking protocol for Allprep isolation</span> <span class="counter" id="count.lysate.1" title="Counting..."><img src="images/loading-small.gif"></span>

					<li><span class="require-permission" data-role="SamplePrep" data-link="sampleproc/extraction_registration.jsp?ID=<%=ID%>"
						>DNA/RNA/FlowThrough registration</span> <span class="counter" id="count.lysate.2" title="Counting..."><img src="images/loading-small.gif"></span>
					</ul>
				</dd>
				<dt>
					<base:icon image="<%=home+"/images/rnaqc.png" %>" />
					RNA quality control wizards
				</dt>
				<dd>
					<ul>
					<li><span class="require-permission" data-role="SamplePrep" data-link="sampleproc/rnaqc_aliquot.jsp?ID=<%=ID%>"
						>Create aliquots on Bioanalyzer/Caliper plates</span> <span class="counter" id="count.rnaqc" title="Counting..."><img src="images/loading-small.gif"></span>
					
					<li><span class="require-permission" data-role="SamplePrep" data-link="sampleproc/rnaqc_plate_export.jsp?ID=<%=ID%>"
						>Export Caliper sample names and run parameters</span> <span class="counter" id="count.caliper-plates.1" title="Counting..."><img src="images/loading-small.gif"></span>
					
					<li><span class="require-permission" data-role="SamplePrep" data-link="sampleproc/rnaqc_plate_import.jsp?ID=<%=ID%>"
						>Import RQS scores from Caliper well table file</span> <span class="counter" id="count.caliper-plates.2" title="Counting..."><img src="images/loading-small.gif"></span>
					</ul>
				</dd>			
				</dl>
			
				<h3>Histology wizards</h3>
				<dl class="leftborder rightborder bottomborder">			
				<dt>
					<base:icon image="<%=home+"/images/histology.png" %>" />
					Embedding and staining wizards
				</dt>
				<dd>
					<ul>
					<li><span class="require-permission" data-role="Histology" data-link="sampleproc/histology_protocol.jsp?ID=<%=ID%>"
						>Lab tracking protocol for FFPE/HE</span> <span class="counter" id="count.histology-lists" title="Counting..."><img src="images/loading-small.gif"></span>
					
					<li><span class="require-permission" data-role="Histology" data-link="sampleproc/histology_block.jsp?ID=<%=ID%>"
						>Register paraffin blocks</span> <span class="counter" id="count.paraffin-blocks" title="Counting..."><img src="images/loading-small.gif"></span>

					<li><span class="require-permission" data-role="Histology" data-link="sampleproc/histology_labels.jsp?ID=<%=ID%>"
						>Download HE glass labels</span>
					
					<li><span class="require-permission" data-role="Histology" data-link="sampleproc/histology_glass.jsp?ID=<%=ID%>"
						>Register HE glass</span> <span class="counter" id="count.paraffin-blocks-without-heglass" title="Counting..."><img src="images/loading-small.gif"></span>
				</dd>
				
				<dt>
					<base:icon image="<%=home+"/images/microscope.png" %>" />
					Scoring wizard
				</dt>
				<dd>
					<li><span class="require-permission" data-role="Histology" data-link="sampleproc/histology_score.jsp?ID=<%=ID%>"
						>Score HE glass</span> <span class="counter" id="count.unscored-heglass" title="Counting..."><img src="images/loading-small.gif"></span>
					</ul>
				</dd>
				</dl>
			
			
				<h3>Library preparation wizards</h3>
				<dl class="leftborder rightborder bottomborder">
			
				<dt>
					<base:icon image="<%=home+"/images/pipette.png" %>" />
					RNA to cDNA wizards
				</dt>
				<dd>
					<ul>
					<li><span class="require-permission" data-role="LibraryPlateDesigner" data-link="libprep/select_rna.jsp?ID=<%=ID%>"
						>Create new mRNA plate</span> <span class="counter" id="count.rna-without-mrna" title="Counting..."><img src="images/loading-small.gif"></span>
					
					<li><span class="require-permission" data-role="LibraryPrep" data-link="libprep/mrna_protocol.jsp?ID=<%=ID%>"
						>Lab protocols for mRNA and cDNA preparation</span> <span class="counter" id="count.mrna-plates" title="Counting..."><img src="images/loading-small.gif"></span>
					
					<li><span class="require-permission" data-role="LibraryPrep" data-link="libprep/rna_dilution_registration.jsp?ID=<%=ID%>"
						>RNA dilution registration</span> <span class="counter" id="count.undiluted-mrna-plates" title="Counting..."><img src="images/loading-small.gif"></span>

					<li><span class="require-permission" data-role="LibraryPrep" data-link="libprep/mrna_registration.jsp?ID=<%=ID%>"
						>mRNA registration and quality control results</span> <span class="counter" id="count.diluted-mrna-plates" title="Counting..."><img src="images/loading-small.gif"></span>
					
					<li><span class="require-permission" data-role="LibraryPrep" data-link="libprep/cdna_registration.jsp?ID=<%=ID%>"
						>cDNA registration</span> <span class="counter" id="count.cdna-plates.1" title="Counting..."><img src="images/loading-small.gif"></span>
					</ul>
				</dd>
				
				<dt>
					<base:icon image="<%=home+"/images/libprep.png" %>" />
					Library preparation wizards
				</dt>
				<dd>
					<ul>
					<li><span class="require-permission" data-role="LibraryPrep" data-link="libprep/assign_barcode.jsp?ID=<%=ID%>"
						>Assign barcodes to cDNA plate</span> <span class="counter" id="count.cdna-plates-for-barcoding" title="Counting..."><img src="images/loading-small.gif"></span>
					
					<li><span class="require-permission" data-role="LibraryPrep" data-link="libprep/libprep_protocol.jsp?ID=<%=ID%>"
						>Lab protocols and files for library preparation</span> <span class="counter" id="count.lib-plates.1" title="Counting..."><img src="images/loading-small.gif"></span>
					
					<li><span class="require-permission" data-role="LibraryPrep" data-link="libprep/libqc_registration.jsp?ID=<%=ID%>"
						>Register quality control results</span> <span class="counter" id="count.lib-plates.2" title="Counting..."><img src="images/loading-small.gif"></span>
					
					<li><span class="require-permission" data-role="LibraryPrep" data-link="libprep/lib_registration.jsp?ID=<%=ID%>"
						>Library registration</span> <span class="counter" id="count.lib-plates.3" title="Counting..."><img src="images/loading-small.gif"></span>
					</ul>
				</dd>
				<dt>
					<base:icon image="<%=home+"/images/pool.png" %>" />
					Pooling wizards
				</dt>
				<dd>
					<ul>
					<li><span class="require-permission" data-role="LibraryPrep" data-link="libprep/create_pools.jsp?ID=<%=ID%>"
						>Create pooled libraries</span> <span class="counter" id="count.lib-plates-for-pooling" title="Counting..."><img src="images/loading-small.gif"></span>
					
					<li><span class="require-permission" data-role="LibraryPrep" data-link="libprep/pool_protocol.jsp?ID=<%=ID%>"
						>Lab protocols for pooling</span> <span class="counter" id="count.pools.1" title="Counting..."><img src="images/loading-small.gif"></span>
					
					<li><span class="require-permission" data-role="LibraryPrep" data-link="libprep/pool_registration.jsp?ID=<%=ID%>"
						>Register pooled libraries</span> <span class="counter" id="count.pools.2" title="Counting..."><img src="images/loading-small.gif"></span>
					</ul>
				</dd>
				
				<dt>
					<base:icon image="<%=home+"/images/flowcell.png" %>" />
					Clustering and sequencing wizards
				</dt>
				<dd>
					<ul>
					<li><span class="require-permission" data-role="LibraryPrep" data-link="libprep/create_flowcells.jsp?ID=<%=ID%>"
						>Create flow cells</span> <span class="counter" id="count.pools.3" title="Counting..."><img src="images/loading-small.gif"></span>
					
					<li><span class="require-permission" data-role="LibraryPrep" data-link="libprep/flowcell_protocol.jsp?ID=<%=ID%>"
						>Lab protocol for clustering and sequencing</span> <span class="counter" id="count.flow-cells.1" title="Counting..."><img src="images/loading-small.gif"></span>
					
					<li><span class="require-permission" data-role="LibraryPrep" data-link="libprep/flowcell_registration.jsp?ID=<%=ID%>"
						>Register clustering</span> <span class="counter" id="count.flow-cells.2" title="Counting..."><img src="images/loading-small.gif"></span>

					<li><span class="require-permission" data-role="LibraryPrep" data-link="libprep/sequencing_started.jsp?ID=<%=ID%>"
						>Register sequencing started</span> <span class="counter" id="count.flow-cells.3" title="Counting..."><img src="images/loading-small.gif"></span>

					<li><span class="require-permission" data-role="LibraryPrep" data-link="libprep/sequencing_ended.jsp?ID=<%=ID%>"
						>Register sequencing ended</span> <span class="counter" id="count.sequencing-run" title="Counting..."><img src="images/loading-small.gif"></span>
					</ul>
				</dd>
				
				</dl>
			</div>
		</div>
		
		<div class="absolutefull" style="width: 34%; left: 33%; right: auto;">
			<div class="absolutefull" style="left: 0.5em; right: 0.5em;">
				<h3>Secondary analysis wizards</h3>
				<dl class="leftborder rightborder bottomborder">
					<dt>
						<base:icon image="<%=home+"/images/server.png" %>" />
						Demux and merge wizards
					</dt>
					<dd>
						<ul>
						<li><span class="require-permission" data-role="SecondaryAnalysis" data-link="analysis/sequencing_confirm.jsp?ID=<%=ID%>"
							>Confirm sequencing completed</span> <span class="counter" id="count.unconfirmed-sequencing-run" title="Counting..."><img src="images/loading-small.gif"></span>
						
						<li><span class="require-permission not-implemented" data-role="SecondaryAnalysis" data-link="analysis/demux_start.jsp?ID=<%=ID%>"
							>Start demux and merge</span> 
						<li><span class="require-permission not-implemented" data-role="SecondaryAnalysis" data-link="analysis/demux_end.jsp?ID=<%=ID%>"
							>Register demux and merge completed</span> 
						</ul>
					</dd>
					
					<dt>
						<base:icon image="<%=home+"/images/align.png" %>" />
						Filter and alignment wizards
					</dt>
					<dd>
						<ul>
						<li><span class="require-permission not-implemented" data-role="SecondaryAnalysis" data-link="analysis/filter_start.jsp?ID=<%=ID%>"
							>Start filter and alignment</span> 
						<li><span class="require-permission not-implemented" data-role="SecondaryAnalysis" data-link="analysis/align_end.jsp?ID=<%=ID%>"
							>Register filter and alignment completed</span> 
						</ul>
					</dd>
					<dt>
					
						<base:icon image="<%=home+"/images/wizard.png" %>" />
						Feature extraction wizards
					</dt>
					<dd>
						<ul>
						<li><span class="require-permission not-implemented" data-role="SecondaryAnalysis" data-link="analysis/feature_start.jsp?ID=<%=ID%>"
							>Start feature extraction</span> 
						<li><span class="require-permission not-implemented" data-role="SecondaryAnalysis" data-link="analysis/feature_end.jsp?ID=<%=ID%>"
							>Register feature extraction completed</span> 
						</ul>
					</dd>
				</dl>
			</div>
		</div>
		
		<div class="absolutefull" style="width: 33%; left: auto;">
			<div class="absolutefull" style="left: 0.5em; right: 1em;">
				<%
				if (isAdmin)
				{
					%>
					<h3>Server administrator wizards</h3>
					<dl class="leftborder rightborder bottomborder">
					<dt>
						<base:icon image="<%=home + "/images/install.png" %>" />
						<span class="require-permission" data-role="Administrator" data-link="admin/install.jsp?ID=<%=ID%>">Installation wizard</span>
					</dt>
					<dd>
						<ul>
						<li>Check that annotation types and other items used by Reggie exists in BASE.
						<li>Create missing items.
						</ul>
					</dd>
					</dl>
					<%
				}
				if (isPatientCurator || isAdmin)
				{
					%>
					<h3>Personal information wizards</h3>
					<dl class="leftborder rightborder bottomborder">
					<dt>
						<base:icon image="<%=home + "/images/personal.png" %>"/>
						<span class="require-permission" data-role="PatientCurator" data-link="personal/persinfo.jsp?ID=<%=ID%>"
							>Pathology referral form registration</span>
					</dt>
					<dd>
						<ul>
						<li>Register new cases and patients.
						<li>Update existing cases and specimen tubes.
						</ul>
					</dd>
					
					<dt>
						<base:icon image="<%=home + "/images/blood.png" %>"/>
						Blood referral form registration
					</dt>
					<dd>
						<ul>
						<li><span class="require-permission" data-role="PatientCurator" data-link="personal/bloodform.jsp?ID=<%=ID%>"
							>Register new/updated blood referral forms and patients</span>
							
						<li><span class="require-permission" data-role="PatientCurator" data-link="personal/bloodfollowupform.jsp?ID=<%=ID%>"
							>Register new/updated follow-up blood referral forms</span>
						</ul>
					</dd>
					
					<dt>
						<base:icon image="<%=home+"/images/consent.png" %>"/>
						<span class="require-permission" data-role="PatientCurator" data-link="personal/consentform.jsp?ID=<%=ID%>"
							>Consent form registration</span>
					</dt>
					<dd>
						<ul>
						<li>Register consent forms.
						</ul>
					</dd>
					
					<dt>
						<base:icon image="<%=home+"/images/export_import.png" %>" />
						Export/import information to/from external registers.
					</dt>
					<dd>
						<ul>
						<li><span class="require-permission" data-role="PatientCurator" data-link="personal/export_monthly_oplist.jsp?ID=<%=ID%>"
							>Export monthly operation list</span>
							
						<li><span class="require-permission" data-role="PatientCurator" data-link="personal/export_inca.jsp?ID=<%=ID%>"
							>INCA export</span>

						<li><span class="require-permission" data-role="PatientCurator" data-link="personal/export_missing_data_sample_list.jsp?ID=<%=ID%>"
							>Export missing data sample list</span>

						<li><span class="require-permission" data-role="PatientCurator" data-link="personal/export_missing_consent_data_sample_list.jsp?ID=<%=ID%>"
							>Export missing consent data sample list</span>
						</ul>
					</dd>
					</dl>
					<%
				}
				%>
				
				<h3>Statistics and reporting wizards</h3>
				<dl class="leftborder rightborder bottomborder">
					<dt>
						<base:icon image="<%=home+"/images/case_summary.png" %>" />
						Case summary
					</dt>
					<dd>
						<table>
						<tr>
							<td><input type="text" class="text" 
								name="caseName" title="Please enter a 7-digit case id" 
								style="width: 25em;"
								onkeypress="if (event.keyCode==13 && this.value) caseSummary()"></td>
							<td><base:button title="Go" image="<%=home+"/images/gonext.png"%>" onclick="caseSummary()"/></td>
						</tr>
						</table>
					</dd>
				
					<dt>
						<base:icon image="<%=home+"/images/report.png" %>" />
						<a href="reports/samplereportgenerator.jsp?ID=<%=ID%>">Sample source report</a>
					</dt>				
					<dd>				
						<ul>
						<li>Sample count report</li> 
						<li>Consent count report</li> 
						<li>Patient count report</li> 
						<li>Overview report</li> 
						<li>Missing sample data report</li> 
						</ul>
					</dd>
					<dt>
						<base:icon image="<%=home+"/images/chart_bar.png" %>" />
						<a href="reports/scanbquartermonthreportgenerator.jsp?ID=<%=ID%>">Sample processing statistics</a>
					</dt>				
					<dd>				
						<ul>
						<li>SCAN-B quarter/month report</li> 
						</ul>
					</dd>
				</dl>
			</div>
		</div>
		</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>