<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">

var debug = 0;
var currentStep = 1;
var turnAroundDateIsValid = false;
var endDateIsValid = false;


function init()
{
	var frm = document.forms['reggie'];
	var seqRuns = getSequencingRuns();

	// Load existing SequencingRun items with no end date
	if (seqRuns != null && seqRuns.length > 0)
	{
		for (var runNo=0; runNo < seqRuns.length; runNo++)
		{
			var seqRun = seqRuns[runNo];
			var flowCell = seqRun.flowCell;
			var name = seqRun.name+': ';

			var numPools = flowCell.pools.length;
			var firstPoolNum = getPoolNum(flowCell.pools[0].name);
			var lastPoolNum = getPoolNum(flowCell.pools[flowCell.pools.length-1].name);

			if (lastPoolNum - firstPoolNum == numPools - 1)
			{
				if (numPools > 1)
				{
					// Display: PoolN -- PoolY
					name += flowCell.pools[0].name + ' — ' + flowCell.pools[flowCell.pools.length-1].name;
				}
				else
				{
					name += flowCell.pools[0].name;
				}
			}
			else
			{
				// Display: PoolN + x more...
				name += flowCell.pools[0].name + ' + ' + (numPools-1) + ' more...';
			}
			
			if (flowCell.FlowCellType)
			{
				name += ' [' + flowCell.FlowCellType + ']';
			}

			// Tooltip is always all pools
			var title = '';
			for (var poolNo=0; poolNo < numPools; poolNo++)
			{
				var pool = flowCell.pools[poolNo];
				if (poolNo > 0) title += ', ';
				title += pool.name;
			}
			
			var option = new Option(name, seqRun.id);
			option.title = title;
			option.seqRun = seqRun;
			frm.seqRuns.options[frm.seqRuns.length] = option;
		}
		sequencingRunOnChange();
	}
	else
	{
		var msg = 'No sequencing runs available for processing.';
		setFatalError(msg);
		return;
	}

	// All is ok
	frm.seqRuns.focus();
}

function getPoolNum(poolName)
{
	var num = poolName.match(/Pool(\d+)/);
	return num ? parseInt(num[1], 10) : null;	
}

function goNextAuto()
{
	goNext(false);
}

function goNext(manual)
{
	setInnerHTML('gonext.message', '');
	if (currentStep == 1)
	{
		if (step1IsValid()) gotoStep2();
	}
	setCurrentStep(currentStep);
}

function step1IsValid()
{
	return true;
}

function step2IsValid()
{
	return turnAroundDateIsValid && endDateIsValid;
}


function getSequencingRuns()
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading sequencing runs...');
		var url = '../SequencingRun.servlet?ID=<%=ID%>&cmd=GetActiveSequencingRuns';		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.sequencingRuns;
}

function sequencingRunOnChange()
{
	var frm = document.forms['reggie'];	
	var seqRun = frm.seqRuns[frm.seqRuns.selectedIndex].seqRun;
	
	setInnerHTML('startDate', formatDate(seqRun.SequencingStart));
	
	var fc = seqRun.flowCell;
	setInnerHTML('flowCellsInRun', '<b>['+seqRun.HiSeqPosition+']</b> ' + fc.FlowCellID);
	setInnerHTML('flowCellType', fc.FlowCellType || '');
	var pools = fc.pools;
	var html = '';
	var libPlateHtml = '';
	for (var poolNo = 0; poolNo < pools.length; poolNo++)
	{
		var pool = pools[poolNo];
		if (poolNo > 0) html += ', ';
		html += Main.encodeTags(pool.name);
		if (pool.LibPlate && libPlateHtml.indexOf(pool.LibPlate.name) == -1)
		{
			if (libPlateHtml.length > 0) libPlateHtml += ', ';
			libPlateHtml += Main.encodeTags(pool.LibPlate.name);
		}
	}
	setInnerHTML('pools', html);
	setInnerHTML('libPlate', libPlateHtml || 'n/a');
	setInnerHTML('comments', Main.encodeTags(seqRun.comments));
}


function formatDate(value)
{
	if (!value) return '';
	if (value.length == 8)
	{
		value = value.substr(0, 4) + '-' + value.substr(4, 2) + '-' + value.substr(6, 2);
	}
	return value;
}


function gotoStep2()
{
	var frm = document.forms['reggie'];
	
	// Disable controls
	frm.seqRuns.disabled = true;

	currentStep = 2;
	Main.show('step.2.section');
	Main.addClass(document.getElementById('step.1.section'), 'disabled');
	Main.show('gocancel');
	Main.show('goregister');
	Main.hide('gonext');
	
	var seqRun = frm.seqRuns[frm.seqRuns.selectedIndex].seqRun;
	
	frm.sequencingComments.value = seqRun.comments;
	setInnerHTML('step.2.title', seqRun.name);
	
	frm.turnAroundDate.focus();
}


function turnAroundDateTimeOnChange()
{
	var frm = document.forms['reggie'];
	turnAroundDateIsValid = false;
	setInputStatus('turnAroundDate', '', '');
	
	var turnAroundDate = frm.turnAroundDate.value;
	var turnAroundTime = frm.turnAroundTime.value;
	
	if (turnAroundDate == '')
	{
		if (document.getElementById('firstBaseReportOk').checked)
		{
			setInputStatus('turnAroundDate', 'Missing date', 'warning');
		}
		turnAroundDateIsValid = true;
		return;
	}
	else
	{
		// Auto-fill the date if it's only given with 4(MMdd) or 6(yyMMdd) digits.
		turnAroundDate = autoFillDate(turnAroundDate);
		frm.turnAroundDate.value = turnAroundDate;

		if (!Dates.isDate(turnAroundDate, 'yyyyMMdd'))
		{
			setInputStatus('turnAroundDate', 'Not a valid date', 'invalid');
			return;
		}
	}
	
	if (turnAroundTime == '')
	{
		setInputStatus('turnAroundDate', 'Missing time', 'invalid');
		return;
	}
	else
	{
		turnAroundTime = autoFillTime(turnAroundTime);
		frm.turnAroundTime.value = turnAroundTime;
		
		if (!Dates.isDate(turnAroundDate + ' ' + turnAroundTime, 'yyyyMMdd HHmm'))
		{
			setInputStatus('turnAroundDate', 'Not a valid time', 'invalid');
			return;
		}
	}
	
	setInputStatus('turnAroundDate', '', 'valid');
	turnAroundDateIsValid = true;
}

function endDateTimeOnChange()
{
	var frm = document.forms['reggie'];
	endDateIsValid = false;
	setInputStatus('endDate', '', '');
	
	var endDate = frm.endDate.value;
	var endTime = frm.endTime.value;
	
	if (endDate == '')
	{
		setInputStatus('endDate', 'Missing date', 'invalid');
		return;
	}
	else
	{
		// Auto-fill the date if it's only given with 4(MMdd) or 6(yyMMdd) digits.
		endDate = autoFillDate(endDate);
		frm.endDate.value = endDate;

		if (!Dates.isDate(endDate, 'yyyyMMdd'))
		{
			setInputStatus('endDate', 'Not a valid date', 'invalid');
			return;
		}
	}
	
	if (endTime == '')
	{
		setInputStatus('endDate', 'Missing time', 'invalid');
		return;
	}
	else
	{
		endTime = autoFillTime(endTime);
		frm.endTime.value = endTime;
		
		if (!Dates.isDate(endDate + ' ' + endTime, 'yyyyMMdd HHmm'))
		{
			setInputStatus('endDate', 'Not a valid time', 'invalid');
			return;
		}
	}

	if (turnAroundDateIsValid)
	{
		var turnAroundTimestamp = Dates.parseString(frm.turnAroundDate.value + ' ' + frm.turnAroundTime.value, 'yyyyMMdd Hmm');
		var endTimestamp = Dates.parseString(frm.endDate.value + ' ' + frm.endTime.value, 'yyyyMMdd Hmm');
		
		if (turnAroundTimestamp != null && turnAroundTimestamp.getTime() >= endTimestamp.getTime())
		{
			setInputStatus('endDate', 'End date must be after turnaround date', 'invalid');
			return;
		}
	}

	setInputStatus('endDate', '', 'valid');
	endDateIsValid = true;
}

function goRegister()
{
	if (!step2IsValid()) return;
	
	var frm = document.forms['reggie'];
	Main.addClass(document.getElementById('step.2.section'), 'disabled');
	frm.turnAroundDate.disabled = true;
	frm.turnAroundTime.disabled = true;
	frm.endDate.disabled = true;
	frm.endTime.disabled = true;
	frm.sequencingComments.disabled = true;
	frm.firstBaseReport[0].disabled = true;
	frm.firstBaseReport[1].disabled = true;
	
	Main.hide('goregister');
	Main.hide('gocancel');
	Main.hide('gonext.message');
	
	var seqRun = frm.seqRuns[frm.seqRuns.selectedIndex].seqRun;
	seqRun.firstBaseReportFailed = document.getElementById('firstBaseReportFailed').checked;
	seqRun.turnAroundDate = Main.trimString(frm.turnAroundDate.value + ' ' + frm.turnAroundTime.value);
	seqRun.endDate = Main.trimString(frm.endDate.value + ' ' + frm.endTime.value);
	seqRun.comments = frm.sequencingComments.value;
	
	var submitInfo = {};
	submitInfo.sequencingRun = seqRun;
	
	if (debug) Main.debug(JSON.stringify(submitInfo));
	var url = '../SequencingRun.servlet?ID=<%=ID%>&cmd=RegisterSequencingEnded';
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Performing registration...');
		request.open("POST", url, false);
		request.send(JSON.stringify(submitInfo));
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);
	
	if (response.messages && response.messages.length > 0)
	{
		var msg = '<ul>';
		for (var i = 0; i < response.messages.length; i++)
		{
			var msgLine = response.messages[i];
			if (msgLine.indexOf('[Warning]') >= 0)
			{
				msg += '<li class="warning">' + msgLine.replace('[Warning]', '');
			}
			else
			{
				msg += '<li>' + msgLine;
			}
		}
		msg += '</ul>';
		setInnerHTML('messages', msg);
		Main.show('messages');
	}
	
	if (response.status != 'ok')
	{
		Main.addClass(document.getElementById('messages'), 'failure');
		setFatalError(response.message);
		return false;
	}

	Main.show('gorestart');	
}



</script>
<style>
.fc-info
{
	background-color: #F4F4F4;
	border-top: 1em solid transparent;
}

.fc-info .subprompt
{
	font-weight: normal;
	padding-left: 2em;
	text-align: left;
}

.fc-info .input
{
	font-style: italic;
}

</style>
</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Register sequencing ended" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</div>
		<%
	}
	%>

	<form name="reggie" onsubmit="return false;">
	
	<div id="step.1.section">
	<table class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Select sequencing run</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table style="border-collapse: collapse;">
			<tr valign="top">
				<td class="prompt">Sequencing run</td>
				<td class="input"><select class="required" style="width:90%;" 
						name="seqRuns" id="seqRuns" onchange="sequencingRunOnChange()"></select>
				</td>
				<td class="status" id="seqRuns.status"></td>
				<td class="help"><span id="seqRuns.message" class="message" style="display: none;"></span>
					Select the sequencing run that has ended.
				</td>
			</tr>
			<tbody class="fc-info">
			<tr valign="top">
				<td class="subprompt">Start date</td>
				<td class="input" id="startDate"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top">
				<td class="subprompt">Flow cell type</td>
				<td class="input" id="flowCellType"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top">
				<td class="subprompt">Flow cell</td>
				<td class="input" id="flowCellsInRun"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top">
				<td class="subprompt">Pools</td>
				<td class="input" id="pools"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top">
				<td class="subprompt">LibPlate</td>
				<td class="input" id="libPlate"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top">
				<td class="subprompt">Comments</td>
				<td class="input" id="comments"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			</tbody>
			</table>
		</td>
	</tr>
	</table>
	</div>
	
	<div id="step.2.section" style="display: none;">
	<table class="stepform">
	<tr>
		<td rowspan="3" class="stepno">2</td>
		<td class="steptitle" id="step.2.title">SequencingRun</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table>
			<tr valign="top">
				<td class="prompt">First base report</td>
				<td class="input">
					<label><input type="radio" name="firstBaseReport" id="firstBaseReportOk" value="1" checked
						onclick="turnAroundDateTimeOnChange()">Ok</label>
					<label><input type="radio" name="firstBaseReport" id="firstBaseReportFailed" value="0"
						onclick="turnAroundDateTimeOnChange()">Not ok</label>
				</td>
				<td class="status" id="firstBaseReport.status"></td>
				<td class="help"><span id="firstBaseReport.message" class="message" style="display: none;"></span>
					If <b>first base report</b> failed and a restart was possible a new <b>sequencing start</b>
					must be registered.
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Turn-around date</td>
				<td class="input"><input type="text" name="turnAroundDate" value="" size="12" maxlength="10" 
						onkeypress="focusOnEnter(event, 'turnAroundTime')" onblur="turnAroundDateTimeOnChange()">
					<span>Time <input type="text" name="turnAroundTime" value="" size="6" maxlength="5" 
						onkeypress="focusOnEnter(event, 'endDate')" onblur="turnAroundDateTimeOnChange()"></span>
				</td>
				<td class="status" id="turnAroundDate.status"></td>
				<td class="help"><span id="turnAroundDate.message" class="message" style="display: none;"></span>Date+time of turnaround (YYYYMMDD, HHMM). 
					Leave empty if sequencing ended before turn-around (eg. due to first base report not ok).</td>
			</tr>
			<tr valign="top">
				<td class="prompt">End date</td>
				<td class="input"><input type="text" name="endDate" class="required" value="" size="12" maxlength="10"
						onkeypress="focusOnEnter(event, 'endTime')" onblur="endDateTimeOnChange()">
					Time <input type="text" name="endTime" class="required" value="" size="6" maxlength="5"
						onblur="endDateTimeOnChange()"></td>
				<td class="status" id="endDate.status"></td>
				<td class="help"><span id="endDate.message" class="message" style="display: none;"></span>Date+time sequencing ended (YYYYMMDD, HHMM)</td>
			</tr>
			
			<tr valign="top">
				<td class="prompt">Comments</td>
				<td class="input"><textarea rows="6" cols="50" style="width: 95%;" name="sequencingComments" value=""></textarea></td>
				<td class="status" id="sequencingComments.status"></td>
				<td class="help"><span id="sequencingComments.message" class="message" style="display: none;"></span>Comments about the sequencing.</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	</div>
		
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="../images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="messages" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>
	
	<table style="margin-left: 20px; margin-top: 10px;" class="navigation">
		<tr>
			<td><base:button id="gocancel" title="Cancel" onclick="goRestart(false)" style="display: none;"/></td>
			<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" onclick="goNext(true)"/></td>
			<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>" onclick="goRegister()" style="display: none;"/></td>
			<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
			<td id="gonext.message" class="message"></td>
		</tr>
	</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>