<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>
	
	
<script language="JavaScript">

var RNA_QC_FILES_PATH = '/home/SCANB/RNAQC';
var firstBrowse = true;
var subtypeInfo = [];

var debug = false;
var hasValididatedCsv = false;
var qcRunDateIsValid = false;

function init()
{
	var frm = document.forms['reggie'];

}

var lastExtension;
function browseOnClick(extension, subtype)
{
	var frm = document.forms['reggie'];
	if (frm[extension+'.path'].disabled) return;
	
	if (firstBrowse)
	{
		firstBrowse = false;
		setCurrentDirectory('<%=ID%>', RNA_QC_FILES_PATH, debug, '../');
	}
	if (subtypeInfo[subtype] == undefined)
	{
		subtypeInfo[subtype] = getSubtypeInfo('<%=ID%>', subtype, debug, '../');
	}
	
	var url = getRoot() + 'filemanager/index.jsp?ID=<%=ID%>&cmd=SelectOne&callback=setFileCallback';
	url += '&resetTemporary=1&tmpfilter:STRING:name='+escape('%.' + extension.substr(0, 3));
	if (subtypeInfo[subtype])
	{
		url += '&tmpfilter:INT:itemSubtype='+subtypeInfo[subtype].id;
	}
	lastExtension = extension;
	Main.openPopup(url, 'SelectFile', 1000, 700);
}


function setFileCallback(id, path)
{
	var frm = document.forms['reggie'];
	frm[lastExtension+'.id'].value = id;
	frm[lastExtension+'.path'].value = path;
	if (lastExtension == 'csv')
	{
		setTimeout(preValidateCsvFile, 100);
	}
	else
	{
		setInputStatus(lastExtension, '', 'valid');
	}
}


function preValidateCsvFile()
{
	var frm = document.forms['reggie'];
	var csvId = frm['csv.id'].value;
	var csvPath = frm['csv.path'].value;
	if (!csvId) return;
	
	Main.hide('messages');
	Main.addClass(document.body, 'please-wait');
	setInputStatus('csv', 'Checking...', 'checking');

	var url = '../RnaQc.servlet?ID=<%=ID%>&cmd=PreValidateCaliperResults&csv='+csvId;
	
	var request = Ajax.getXmlHttpRequest();
	Ajax.setReadyStateHandler(request, onCsvValidated);
	request.open("POST", url, true);	
	request.send('');
	
}

function onCsvValidated(request)
{
	Main.removeClass(document.body, 'please-wait');
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	
	var numWarnings = 0;
	Main.removeClass(document.getElementById('messages'), 'failure'); // reset failure status of messages
	if (response.messages && response.messages.length > 0)
	{
		var messages = '<ul>';
		for (var i = 0; i < response.messages.length; i++)
		{
			var msgLine = response.messages[i];
			if (msgLine.indexOf('[Warning]') >= 0)
			{
				messages += '<li class="warning">' + msgLine.replace('[Warning]', '');
				numWarnings++;
			}
			else
			{
				messages += '<li>' + msgLine;
			}
		}
		messages += '</ul>';
		setInnerHTML('messages', messages);
		Main.show('messages');
	}
	else
	{
		Main.hide('messages');	
	}
	
	if (response.status != 'ok')
	{
		setInputStatus('csv', response.message, 'invalid');
		Main.addClass(document.getElementById('messages'), 'failure');
		hasValidatedCsv = false;
		Main.hide('bioplateSection');
		return;
	}

	setInputStatus('csv', '', numWarnings > 0 ? 'warning' : 'valid');
	hasValidatedCsv = true;
	
	var bioplate = response.plate;
	
	Main.show('bioplateSection');
	setInnerHTML('bioplate.name', '<span class="link" onclick="bioPlateOnClick(event, '+bioplate.id+')">'+bioplate.name+'</a>');
	setInputStatus('bioplate', '', 'valid');
	if (bioplate.QCRunDate)
	{
		frm.qcRunDate.value = bioplate.QCRunDate;
		qcRunDateOnChange();
		setInputStatus('bioplate', 'Data has already been imported to this plate', 'warning');
	}
	else
	{
		// Try to get date from the filename
		var dates = csvPath.match(/\d\d\d\d-\d\d-\d\d/);
		if (dates && dates.length >= 1)
		{
			var date = dates[0];
			frm.qcRunDate.value = date.substr(0, 4)+date.substr(5, 2)+date.substr(8, 2);
			qcRunDateOnChange();
		}
		
	}
	if (bioplate.QCOperator)
	{
		frm.qcOperator.value = bioplate.QCOperator;	
	}
	
}

function bioPlateOnClick(event, id)
{
	Main.itemOnClick(event, '<%=ID%>', 'BIOPLATE', id, true);
}

function goImport()
{
	var frm = document.forms['reggie'];
	var csvId = parseInt(frm['csv.id'].value, 10);
	var gxdStdId = parseInt(frm['gxd.std.id'].value, 10);
	var gxdHiId = parseInt(frm['gxd.hi.id'].value, 10);
	var pdfId = parseInt(frm['pdf.id'].value, 10);
	
	if (!csvId)
	{
		setInputStatus('csv', 'Missing CSV file', 'invalid');
		return;
	}
	if (!hasValidatedCsv) return;
	if (frm.qcRunDate.value != '' && !qcRunDateIsValid) return;
	
	setInputStatus('csv', '', 'valid');
	
	Main.hide('goimport');
	Main.hide('messages');

	frm['csv.path'].disabled = true;
	frm['gxd.std.path'].disabled = true;
	frm['gxd.hi.path'].disabled = true;
	frm['pdf.path'].disabled = true;
	Main.addClass(document.getElementById('btnCsv'), 'disabled');
	Main.addClass(document.getElementById('btnGxdStd'), 'disabled');
	Main.addClass(document.getElementById('btnGxdHi'), 'disabled');
	Main.addClass(document.getElementById('btnPdf'), 'disabled');
	
	var submitInfo = new Object();
	submitInfo.csv = csvId;
	submitInfo.gxdStd = gxdStdId;
	submitInfo.gxdHi = gxdHiId;
	submitInfo.pdf = pdfId;
	submitInfo.QCRunDate = frm.qcRunDate.value;
	submitInfo.QCOperator = frm.qcOperator.value;
	
	if (debug) Main.debug(JSON.stringify(submitInfo));
	
	var url = '../RnaQc.servlet?ID=<%=ID%>&cmd=ImportCaliperResults';
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Importing RQS values...');
		request.open("POST", url, false);
		request.send(JSON.stringify(submitInfo));
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);
	
	Main.removeClass(document.getElementById('messages'), 'failure'); // reset failure status of messages
	if (response.messages && response.messages.length > 0)
	{
		var msg = '<ul>';
		for (var i = 0; i < response.messages.length; i++)
		{
			var msgLine = response.messages[i];
			if (msgLine.indexOf('[Warning]') >= 0)
			{
				msg += '<li class="warning">' + msgLine.replace('[Warning]', '');
			}
			else
			{
				msg += '<li>' + msgLine;
			}
		}
		msg += '</ul>';
		setInnerHTML('messages', msg);
		Main.show('messages');
	}
	
	if (response.status != 'ok')
	{
		Main.addClass(document.getElementById('messages'), 'failure');
		setFatalError(response.message);
		return false;
	}

	Main.show('done');
	Main.show('gorestart');
	
}


function qcRunDateOnChange()
{
	var frm = document.forms['reggie'];
	qcRunDateIsValid = false;
	setInputStatus('qcRunDate', '', '');
	
	var qcRunDate = frm.qcRunDate.value;
	
	if (qcRunDate == '')
	{
		setInputStatus('qcRunDate', 'Missing', 'warning');
	}
	else
	{
		// Auto-fill the date if it's only given with 4(MMdd) or 6(yyMMdd) digits.		
		qcRunDate = autoFillDate(qcRunDate);
		frm.qcRunDate.value = qcRunDate;
	
		if (!Dates.isDate(qcRunDate, 'yyyyMMdd'))
		{
			setInputStatus('qcRunDate', 'Not a valid date', 'invalid');
			return;
		}
		setInputStatus('qcRunDate', '', 'valid');
	}
	
	qcRunDateIsValid = true;
}

</script>

<style>
body.please-wait
{
	cursor: wait !important;
}
</style>

</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="RNA quality control - Import Caliper results" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the import but 
			you may not be able to update all items.
		</div>
		<%
	}
	%>

	<form name="reggie" onsubmit="return false;">
		<input type="hidden" name="csv.id" value="">
		<input type="hidden" name="gxd.std.id" value="">
		<input type="hidden" name="gxd.hi.id" value="">
		<input type="hidden" name="pdf.id" value="">
	
	<!-- 1. Select bioplate -->
	<table border="0" cellspacing="0" cellpadding="0" class="stepform">
	<tr>
		<td rowspan="2" class="stepno">1</td>
		<td class="steptitle">Select data files</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
			<tr valign="top">
				<td class="prompt">Well table CSV</td>
				<td class="input">
							<table border="0" cellspacing="0" cellpadding="0">
							<tr>
							<td><input class="text required" type="text" 
								name="csv.path" value=""
								size="50"></td>
							<td style="padding-left: 4px;"><base:button 
									title="Browse&hellip;"
									onclick="browseOnClick('csv', 'CALIPER_WELL_TABLE')"
									id="btnCsv"
									/>
							</td>
							</tr>
							</table>
					
				</td>
				<td class="status" id="csv.status"></td>
				<td class="help"><span id="csv.message" class="message" style="display: none;"></span>
					Select the <b>Well Table CSV file</b> that contains the exported analysis result from the
					Caliper software.
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">GXD standard</td>
				<td class="input">
							<table border="0" cellspacing="0" cellpadding="0">
							<tr>
							<td><input class="text" type="text" 
								name="gxd.std.path" value=""
								size="50"></td>
							<td style="padding-left: 4px;"><base:button 
									title="Browse&hellip;"
									onclick="browseOnClick('gxd.std', 'CALIPER_RAW_DATA')"
									id="btnGxdStd"
									/>
							</td>
							</tr>
							</table>
					
				</td>
				<td class="status" id="gxd.std.status"></td>
				<td class="help"><span id="gxd.std.message" class="message" style="display: none;"></span>
					Select the <b>Standard GXD file</b> that contains the raw data.
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">GXD high sense</td>
				<td class="input">
							<table border="0" cellspacing="0" cellpadding="0">
							<tr>
							<td><input class="text" type="text" 
								name="gxd.hi.path" value=""
								size="50"></td>
							<td style="padding-left: 4px;"><base:button 
									title="Browse&hellip;"
									onclick="browseOnClick('gxd.hi', 'CALIPER_RAW_DATA')"
									id="btnGxdHi"
									/>
							</td>
							</tr>
							</table>
					
				</td>
				<td class="status" id="gxd.hi.status"></td>
				<td class="help"><span id="gxd.hi.message" class="message" style="display: none;"></span>
					Select the <b>High sense GXD file</b> that contains the raw data.
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">PDF file</td>
				<td class="input">
							<table border="0" cellspacing="0" cellpadding="0">
							<tr>
							<td><input class="text" type="text" 
								name="pdf.path" value=""
								size="50"></td>
							<td style="padding-left: 4px;"><base:button 
									title="Browse&hellip;"
									onclick="browseOnClick('pdf', 'CALIPER_PDF')"
									id="btnPdf"
									/>
							</td>
							</tr>
							</table>
					
				</td>
				<td class="status" id="pdf.status"></td>
				<td class="help"><span id="pdf.message" class="message" style="display: none;"></span>
					Select the PDF file that contains a printout with diagrams and other
					useful documentation.
				</td>
			</tr>
			<tr id="bioplateSection">
				<td class="prompt">Bioplate</td>
				<td class="input" id="bioplate.name"><i>no file loaded</i></td>
				<td class="status" id="bioplate.status"></td>
				<td class="help"><span id="bioplate.message" class="message" style="display: none;"></span>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">QC Run Date</td>
				<td class="input" style="padding-left: 0px;">
					<input type="text" name="qcRunDate" value="" size="12" maxlength="10"
						onblur="qcRunDateOnChange()">
				</td>
				<td class="status" id="qcRunDate.status"></td>
				<td class="help">
					<span id="qcRunDate.message" class="message" style="display: none;"></span>(YYYYMMDD or MMDD)
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">QC Operator</td>
				<td class="input" style="padding-left: 0px;">
					<input type="text" name="qcOperator" value="<%=HTML.encodeTags(user.getName()) %>" size="50" maxlength="255">
				</td>
				<td class="status" id="qcOperator.status"></td>
				<td class="help">
					<span id="qcOperator.message" class="message" style="display: none;"></span>
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="../images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="messages" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>
	
	<table style="margin-left: 20px; margin-top: 10px;" class="navigation">
		<tr>
			<td><base:button id="goimport" title="Import" image="<%=home+"/images/import.png"%>" onclick="goImport()"/></td>
			<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
			<td id="gonext.message" class="message"></td>
		</tr>
	</table>
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>